import { CHTMLWrapper } from '../Wrapper.js';
import { CHTMLWrapperFactory } from '../WrapperFactory.js';
import { CHTMLmsubsup, CHTMLmsub, CHTMLmsup } from './msubsup.js';
import { MmlNode } from '../../../core/MmlTree/MmlNode.js';
import { BBox } from '../BBox.js';
import { StyleList } from '../CssStyles.js';
export declare class CHTMLmunder extends CHTMLmsub {
    static kind: string;
    static useIC: boolean;
    static styles: StyleList;
    readonly script: CHTMLWrapper;
    constructor(factory: CHTMLWrapperFactory, node: MmlNode, parent?: CHTMLWrapper);
    toCHTML(parent: HTMLElement): void;
    computeBBox(bbox: BBox): void;
}
export declare class CHTMLmover extends CHTMLmsup {
    static kind: string;
    static useIC: boolean;
    static styles: StyleList;
    readonly script: CHTMLWrapper;
    constructor(factory: CHTMLWrapperFactory, node: MmlNode, parent?: CHTMLWrapper);
    toCHTML(parent: HTMLElement): void;
    computeBBox(bbox: BBox): void;
}
export declare class CHTMLmunderover extends CHTMLmsubsup {
    static kind: string;
    static useIC: boolean;
    static styles: StyleList;
    readonly under: CHTMLWrapper;
    readonly over: CHTMLWrapper;
    readonly sub: CHTMLWrapper;
    readonly sup: CHTMLWrapper;
    constructor(factory: CHTMLWrapperFactory, node: MmlNode, parent?: CHTMLWrapper);
    toCHTML(parent: HTMLElement): void;
    computeBBox(bbox: BBox): void;
}
